#include <stdio.h>
#include <stdlib.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_eigen.h>

int main()
{
    int N=3;
    int i;
    double a_data[]={2,6,4,6,3,2,4,2,-2};
    gsl_matrix_view m=gsl_matrix_view_array(a_data,N,N);
    gsl_vector *eval = gsl_vector_alloc (N);
    gsl_matrix *evec = gsl_matrix_alloc (N, N);


    gsl_eigen_symmv_workspace * w = gsl_eigen_symmv_alloc (N);
    gsl_eigen_symmv(&m.matrix, eval, evec, w);
    gsl_eigen_symm_free (w);

    for (i = 0; i < N; i++)
    {
        double eval_i= gsl_vector_get (eval, i);
        gsl_vector_view evec_i= gsl_matrix_column (evec, i);
        printf ("eigenvalue = %g\n", eval_i);
        printf ("eigenvector = \n");
        gsl_vector_fprintf (stdout, &evec_i.vector, "%g");
      }
    return 0;
}
