#include <stdio.h>
#include <stdlib.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
void gsl_print_matrix_elements(gsl_matrix * m);
int main()
{
    int M=5;
    int i;
    gsl_matrix * my_identity_matrix = gsl_matrix_alloc (M, M);
    gsl_matrix_set_identity (my_identity_matrix);
    gsl_permutation * p = gsl_permutation_calloc (M);
    gsl_permutation_init (p);
    do
    {
         printf("\n P E R M U T A T I O N TABLE=");
         gsl_matrix * p_matrix = gsl_matrix_alloc (M, M);
         gsl_permutation_fprintf (stdout, p, " %u");

         for(i=0; i<M; i++){
                int pid=gsl_permutation_get ( p, i);
                gsl_vector * v = gsl_vector_alloc (M);
                gsl_matrix_get_row (v, my_identity_matrix, pid);
                gsl_matrix_set_row(p_matrix,i,v);
                gsl_vector_free (v);
         }
         gsl_print_matrix_elements(p_matrix);
         gsl_matrix_free (p_matrix);
          printf("\n");
    }
    while (gsl_permutation_next(p) == GSL_SUCCESS);
    gsl_matrix_free (my_identity_matrix);

    return 0;
}


void gsl_print_matrix_elements(gsl_matrix * m){
    int i, j;
    for (i = 0; i < m->size1; i++){
     printf("\n");
            for (j = 0; j < m->size2; j++)
                    printf ("\t [%g]\t", gsl_matrix_get (m, i, j));
        }
}
