#include <gsl/gsl_matrix.h>
void gsl_set_matrix_elements(gsl_matrix * m);
void gsl_print_matrix_elements(gsl_matrix * m);
void gsl_print_matrix_view_elements(gsl_matrix_view mv);
int main (void)
{
        gsl_matrix * m = gsl_matrix_alloc (10, 3);
        gsl_set_matrix_elements(m);

        printf("[A] ");
        gsl_print_matrix_elements(m);

        gsl_matrix_view mv = gsl_matrix_submatrix(m, 0, 0, 2, 2);

        gsl_matrix *B = gsl_matrix_alloc (2, 2);
        gsl_matrix_memcpy (B, &mv.matrix);
        gsl_matrix_set (B, 0, 0, 100);

        printf("\n[B] ");
        gsl_print_matrix_elements(B);
        gsl_matrix_free (m);
return 0;
}

void gsl_set_matrix_elements(gsl_matrix * m){
        int i, j;
        for (i = 0; i < m->size1; i++)
            for (j = 0; j < m->size2; j++)
            gsl_matrix_set (m, i, j, i + j);
}

void gsl_print_matrix_elements(gsl_matrix * m){
    int i, j;
    for (i = 0; i < m->size1; i++){
            printf("\n");
            for (j = 0; j < m->size2; j++)
                    printf ("[%d,%d)] = %g\t", i, j, gsl_matrix_get (m, i, j));
        }
}

void gsl_print_matrix_view_elements(gsl_matrix_view mv){
        int i, j;
        for (i = 0; i < mv.matrix.size1; i++){
            printf("\n");
            for (j = 0; j < mv.matrix.size2; j++)
                    printf ("[%d,%d] = %g\t", i, j, gsl_matrix_get (&mv.matrix, i, j));
         }

}
